--[[ For normal milling w/o information for skipped "herbs" the macro should be: /run MillButtonSetup() /click MillButton ]]
--[[ For normal milling w/ information for skipped "herbs" the macro should be: /run MillButtonSetup2() /click MillButton ]]

local L = LibStub("AceLocale-3.0"):GetLocale("MillButton")
local mill = CreateFrame("CheckButton","MillButton",UIParent,"SecureActionButtonTemplate")
mill:SetAttribute("type","macro")
local _, _, _, _, _, item_herb = GetAuctionItemSubClasses(6) --Simple way to get ingame localized ItemType "Herb" through Auctionshouseframe translation
local mill_spell = GetSpellInfo(51005) --SpellID for Milling

--[[
	Optionstable
]]
MillButton_DefaultOptions = {
	version = "1.0",
	extended = false	--fr die Optionale Chatausgabe der bersrpungenen Kruter (entfllt evtl.)
};
--[[
	Expansiontable
]]
MillButtonExpansions = {
	"Classic",
	"Burning Crusade",
	"Wrath of the Lich King",
	"Cataclysm",
	"Mists of Pandaria",
	"Warlords of Draenor"
};
--[[
	NEW Code BEGINN
]]

local ADDON, Addon = ...

local frame = CreateFrame("Frame")
frame:RegisterEvent("ADDON_LOADED")
--frame:RegisterEvent("PLAYER_LOGOUT")

frame:SetScript("OnEvent", function(self, event, arg1)
	if event == "ADDON_LOADED" and arg1 == "MillButton" then
		if MillButtonDB == nil then
			MillButtonDB = MillButton_Herblist
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00MillButton: |r Default settings loaded")
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00MillButton: |r Settings loaded")
		end
		if MillButtonSettings == nil then
			MillButtonSettings = MillButton_DefaultOptions
		end
	end
end)

local Options = CreateFrame("Frame", ADDON.."Options", InterfaceOptionsFramePanelContainer)
Options.name = GetAddOnMetadata(ADDON, "Title") or ADDON
InterfaceOptions_AddCategory(Options)
Addon.OptionsPanel = Options

Options:SetScript("OnShow", function()
	local Title = Options:CreateFontString("$parentTitle", "ARTWORK", "GameFontNormalLarge")
	Title:SetPoint("TOPLEFT", 16, -16)
	Title:SetText(Options.name)
	
	local Notes = Options:CreateFontString("$parentSubText", "ARTWORK", "GameFontHighlightSmall")
	Notes:SetPoint("TOPLEFT", Title, "BOTTOMLEFT", 0, -8)
	Notes:SetPoint("RIGHT", -32, 0)
	Notes:SetHeight(8)
	Notes:SetJustifyH("LEFT")
	Notes:SetJustifyV("TOP")
	Notes:SetText("Version: "..GetAddOnMetadata(ADDON, "Version"))
		
	local OptionPanel = CreateFrame("Frame", nil, Options)
	OptionPanel:SetPoint("TOPLEFT", Notes, "BOTTOMLEFT", 0, -24)
	OptionPanel:SetPoint("BOTTOMRIGHT", Options, -16, 16)
	OptionPanel:SetBackdrop({
		bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 16, edgeSize = 16,
		insets= { left = 3, right = 3, top = 5, bottom = 3 }
	})
	OptionPanel:SetBackdropColor(0.1, 0.1, 0.1, 0.5)
	OptionPanel:SetBackdropBorderColor(0.4, 0.4, 0.4)
	
	local myCheckButton = CreateFrame("CheckButton", "myCheckButton_GlobalName", OptionPanel, "ChatConfigCheckButtonTemplate")
	myCheckButton:SetPoint("TOPLEFT", 16, -16)
	myCheckButton_GlobalNameText:SetText("MillButton Extended")
	myCheckButton.tooltip = "This is where you place MouseOver Text."
	myCheckButton:SetScript("OnClick", 
	function()
		PlaySound("igMainMenuOptionCheckBoxOn" or "igMainmenuOptionCheckBoxOff")
		local isChecked = myCheckButton:GetChecked()
		if isChecked == true then 
			MillButtonSettings.extended = true
			print(MillButtonSettings.extended)
		else
			MillButtonSettings.extended = false
			print(MillButtonSettings.extended)
		end			
	end)
	myCheckButton:SetChecked(MillButtonSettings.extended)
	
	for i = 1, #MillButtonExpansions do
		-- Make a child panel
		local Options_Child = CreateFrame("Frame", ADDON.."Child", Options)
		Options_Child.name = MillButtonExpansions[i]
		Options_Child.id = i
		-- Specify childness of this panel (this puts it under the little red [+], instead of giving it a normal AddOn category)
		Options_Child.parent = Options.name
		-- Add the child to the Interface Options
		InterfaceOptions_AddCategory(Options_Child)
		
		local Title = Options_Child:CreateFontString("$parentTitle", "ARTWORK", "GameFontNormalLarge")
		Title:SetPoint("TOPLEFT", 16, -16)
		Title:SetText(Options_Child.name)
		
		local SubOptionPanel = CreateFrame("Frame", nil, Options_Child)
		SubOptionPanel:SetPoint("TOPLEFT", Title, "BOTTOMLEFT", 0, -24)
		SubOptionPanel:SetPoint("BOTTOMRIGHT", Options_Child, -16, 16)
		SubOptionPanel:SetBackdrop({
			bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			tile = true, tileSize = 16, edgeSize = 16,
			insets= { left = 3, right = 3, top = 5, bottom = 3 }
		})
		SubOptionPanel:SetBackdropColor(0.1, 0.1, 0.1, 0.5)
		SubOptionPanel:SetBackdropBorderColor(0.4, 0.4, 0.4)
		
		Options_Child:SetScript("OnShow",
			function()
			PlaySound("igMainMenuOptionCheckBoxOn" or "igMainmenuOptionCheckBoxOff")
			local expansion = Options_Child.name
			print(expansion.." clicked")
		end)
		
	end
	
	Options:SetScript("OnShow", nil)
		
end)
	
SLASH_MILLBUTTON1 = "/millbutton"
SLASH_MILLBUTTON2 = "/mbtn"
SlashCmdList.MILLBUTTON = function() InterfaceOptionsFrame_OpenToCategory(Options) end
	
--[[
	NEW Code ENDE
]]

local function findherb()
	for bag=0,4 do	--search only in our bags for herbs 0=default bag 1 to 4 additional bagslots
		for slot=1,GetContainerNumSlots(bag) do		--start at slot 1
			local itemID = GetContainerItemID(bag, slot)
			local _, count = GetContainerItemInfo(bag, slot)
			if itemID and not MillButton_Herbs.NotMillable[itemID] then
				local itemName, itemLink, _, _, _, _, itemType = GetItemInfo(itemID)
				if (MillButton_Herbs.Millable[itemID] or itemType==item_herb) and count >= 5 then
					return bag, slot
				end
			end
			if itemID and MillButton_Herbs.NotMillable[itemID] and MillButtonDB.Options.extended==true then
				local itemName, itemLink, _, _, _, _, itemType = GetItemInfo(itemID)
				DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00MillButton: |r"..itemLink.." "..L["skipped"].." "..count.."x")
			end
		end
	end
end

function MillButtonSetup()
extended_millbutton = false
	local bag, slot = findherb()
	if (not bag or not slot) or LootFrame:IsVisible() or CastingBarFrame:IsVisible() or UnitCastingInfo("player") then
	-- do nothing if no herb, if looting or casting
		MillButton:SetAttribute("macrotext","")
		if not bag then
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00MillButton: |r"..L["error"])
		end
	else
		MillButton:SetAttribute("macrotext","/"..L["macro_cast"].." "..mill_spell.."\n/"..L["macro_use"].." "..bag.." "..slot)
	end
end

function MillButtonSetup2()
extended_millbutton = true
	local bag, slot = findherb()
	if (not bag or not slot) or LootFrame:IsVisible() or CastingBarFrame:IsVisible() or UnitCastingInfo("player") then
	-- do nothing if no herb, if looting or casting
		MillButton:SetAttribute("macrotext","")
		if not bag then
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00MillButton: |r"..L["error"])
		end
	else
		MillButton:SetAttribute("macrotext","/"..L["macro_cast"].." "..mill_spell.."\n/"..L["macro_use"].." "..bag.." "..slot)
	end
end